import java.awt.Robot;
import processing.video.Capture;
import gab.opencv.*;
import org.opencv.core.Core;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.event.KeyEvent;
//import org.opencv.features2d.ORB;


// This constants can be changed to get best results
public final int threshold=300;// Grenze, wie viele Pixel(*50) die Pupille weiter rechts/links von der Mitte sein muss, damit die Richtung erkannt wird.
public static final int pupilSize=100;// Size of pupil in pixel
public boolean keyPressesDirection=false;// looking left/right creates up/down keyPresses
public final boolean keyPressesBlink=false;// Blink creates up key press
public static final int minPupilRadius=4;// min radius of pupil
public static final int maxPupilRadius=15;// max radius of pupil
public static final float followFactor=0.2; // if eye position is fixed 


Capture video;// Grabs Videostream of webcam
Rectangle fix=null;//Fixed rectangle for left eye
Rectangle lastEye=null;//Eye movements are detected twice to get more reliable results, the second time the movement is only detected in the eye-area of the frame before
OpenCV opencv;//OpenCV Object to detect Face with face cascade
Robot r;//The Robot Object is used for Virtual KeyInputs
Rectangle[] eyes;//Array of surrounding rectangles of eyes
Rectangle lastface;//Saves the position of the last face detected, to increase detection speed
OpenCV cv2;//Cascade for detecting eyes
double lastdx=0.0;//Last distance between pupil and center-eye position in X-Direction(The program currently doesn't detect Y Movement)
double calib=0.0;
int num=0;
Rectangle face=new Rectangle(0, 0, 1, 1);// saves face for Multithreading
PImage img2;//
void setup() {
  try {
    r=new Robot();
  }
  catch(Exception e) {
  }
  size(700, 360);

  opencv = new OpenCV(this, 480, height);// create OpenCV Object
  opencv.loadCascade(OpenCV.CASCADE_FRONTALFACE);//Load Face Cascade to detect face
  cv2=new OpenCV(this, 480, height);// Same for Eyes
  cv2.loadCascade(OpenCV.CASCADE_EYE);


  //frameRate(3);
  // Fix to chooses the right camera, if the program doesnt work and you have installed the required libraries, heres the Point where you should change something
  if (Capture.list().length==1) {
    video = new Capture(this, 1280, 720, "Integrated Camera: Integrated C");
  } else {
    video = new Capture(this, 1280, 720);
  }
  video.start();
}
void draw() {
  //clear();
  long start=millis();
  if (video.available()) {
    video.read();
    PImage img=video.get();
    img=img.get(160, 0, 960, 720);
    PImage img3=new PImage((Image) img.getNative());//Saves the image for later use at diffrent position in RAM
    img.resize(480, height);// Smaller resolution makes processing faster
    img.filter(GRAY);// Process Gryscale Images

    if (lastface!=null) {
      //img=img.get(lastface.x,lastface.y,lastface.width,lastface.height);
      opencv.setROI(lastface.x, lastface.y, lastface.width, lastface.height);//Only detect face at the position of last face(increases speed)
    } else {
      opencv.setROI(0, 0, 480, height);//if there wasnt a face detected last frame, the Cascade searches the face at whole image
    }
    opencv.loadImage(img);//Load image for face detection
    image(img, 0, 0);// draw Camera Image
    Rectangle[] faces=getFaces();//Function returns the faces detected in the Image as rectangles


    if (faces.length != 0) {
      if (lastface!=null) {
        for (int i=0; i<faces.length; i++) {
          faces[i].x+=lastface.x;// Fix position offset due to setting ROI
          faces[i].y+=lastface.y;
        }
      }

      lastface=new Rectangle(faces[0].x-20, faces[0].y-20, faces[0].width+40, faces[0].height+40);// This Rectangle is the region of interest for the next face detection
      lastface=lastface.intersection(new Rectangle(0, 0, 480, height));// Prevents a rectangle bigger than Image size
      printFaces(color(0, 0, 255), faces);// Draw Rectangles around detected Faces
      //img2=img.get(faces[0].x, faces[0].y, faces[0].width, (int)(faces[0].height/1.5));
      img2=img;//Eyes are detected without reduced resolution
      Rectangle[] eyes=getEyes(faces[0]);// Detect Eyes with Eyecascade
      if (eyes!=null) {//If Eyes are detected
        if (eyes.length<2&&keyPressesBlink) {//the number of eyes is an indicator wether you blink or not
          r.keyPress(KeyEvent.VK_UP);//If set constant keyPressesBlink to true, blink will create an up-key press
          thread("releaseup");//releases key
        }
        detectPupil(eyes, img3,faces[0]);
      }
      printEyes(color(0, 255, 0), eyes);//Draws Rectangles around every eye
    } else { 
      lastface=null;//if no face is detected the last time the face is searched in the whole image
    }
  }
  //println(millis()-start);
}
/**
*Detects Face
*
**/
Rectangle[] getFaces() {
  Rectangle[] faces = opencv.detect();
  return faces;
}
/**
* The Method draws rectangles around faces.
* @param drawColor Color of the rectangle
* @param faces Array of Rectangles surrounding the faces.
**/
void printFaces(color drawColor, Rectangle[] faces) {
  noFill();
  stroke(drawColor);
  strokeWeight(3);
  for (int i = 0; i<faces.length; i++) rect(faces[i].x, faces[i].y, faces[i].width, faces[i].height);
}
/**
* Returns Rectangles of the eye positions, because of Multithreading the function returns only the position of the last eye detection.
* @param face only search for eyes in region of face
**/
Rectangle[] getEyes(Rectangle face) { 
  this.face=face;
  thread("cvthreadeyes");
  //cvthreadeyes();
  //opencv.loadCascade(OpenCV.CASCADE_NOSE);
  //Rectangle[] noses = opencv.detect();
  if (eyes!=null) {

    return eyes;// 
  } else return null;
}
/**
* Eye detection class without parameters for Multithreading. Saves the Eye position in a global variable eyes, so the program in diffrent thread has access to it.
*
**/
void cvthreadeyes() {

  cv2.loadImage(img2);
  cv2.setROI(face.x, face.y, face.width, (int)(face.height/1.5));
  Rectangle ROI=face;
  //OpenCV cv2=new OpenCV(this, img2);
  //cv2.loadCascade(OpenCV.CASCADE_EYE);
  eyes = cv2.detect();
  if (eyes!=null) {
    for (int i = 0; i<eyes.length; i++) {

      //for (int k = 0; k<noses.length; k++) if (eyes[i]!=null && noses[k].contains(eyes[i])) eyes[i] = null;
      if (eyes[i]!=null) {
        eyes[i].x+=(face.x);
        eyes[i].y+=(face.y);
      }
    }
  }
}

/**
* Functionod for detecting pupil position and generating key Inputs depending on viewing direction
*
* @param eyes Rectangles suurounding the eyes
* @param face Rectangle surrounding the face, needed for Reference point
* @param videoimg Image in original resolution
**/
void detectPupil(Rectangle[] eyes, PImage videoimg,Rectangle face) {
  if (eyes.length>1) {
    if (eyes[0].x>eyes[1].x) {
      Rectangle zwischen=eyes[0];
      eyes[0]=eyes[1];
      eyes[1]=zwischen;
    }
    lastEye=eyes[0];
    
    if(fix!=null){
      fix.x-=(fix.x-eyes[0].x)*followFactor;
      fix.y-=(fix.y-eyes[0].y)*followFactor;
      eyes[0]=fix;
    }
    PImage eye1=videoimg.get(eyes[0].x*2, eyes[0].y*2, eyes[0].width*2, eyes[0].height*2);
    //eye1.save("/home/johan/eye/1/"+num+".png");
    
    image(eye1, 480, 0);
    OpenCV eyecv=new OpenCV(this, eye1.width, eye1.height);
    eyecv.loadImage(setThreshold(eye1));
    //eyecv.gray();
    //eyecv.blur(4);

    //eyecv.threshold(63);
    //eyecv.erode();
    image(eyecv.getOutput(), 480, 200);
    //eyecv.threshold(70);
    //eyecv.loadCascade("eye.xml");
    //Rectangle[] lefteye=eyecv.detect();
    ArrayList<Contour> c=eyecv.findContours();
    int index=leastCircularity(c);
    byte lastDir=0;
    if (index!=-1) {
      rect((float)midx(c.get(index))/2.0+eyes[0].x, (float) midy(c.get(index))/2.0+eyes[0].y, 2, 2);
      
      double dx=midx(c.get(index))/2.0-eyes[0].width/2.0;
      //double dx=midx(c.get(index))/2.0-face.width/4.0;
      lastdx=dx;
      dx-=calib;
      
      int dxi=(int)(dx*100.0);
      if (Math.abs(dxi)>threshold) {
        if (dxi>0) {
          lastDir=-1;
        } else {          
          lastDir=1;
        }
      } else {
        lastDir=0;
      }

      text(dxi, 240, 100);
      drawContours(c);
    }
    while (!video.available()) {print("");//Sadly needed to prevent freeze
    }
    //Detects the pupil positions a second time to prevent wrong inputs.
    PImage newEye=video.get();
    eye1=videoimg.get(eyes[0].x*2, eyes[0].y*2, eyes[0].width*2, eyes[0].height*2);
    eyecv=new OpenCV(this, eye1.width, eye1.height);
    eyecv.loadImage(setThreshold(eye1));
    c=eyecv.findContours();
    index=leastCircularity(c);
    if (index!=-1) {
      rect((float)midx(c.get(index))/2.0+eyes[0].x, (float) midy(c.get(index))/2.0+eyes[0].y, 2, 2);
      double dx=midx(c.get(index))/2.0-eyes[0].width/2.0;
      //double dx=midx(c.get(index))/2.0-face.width/4.0;
      lastdx=dx;
      dx-=calib;
      int dxi=(int)(dx*100.0);
      stroke(0, 255, 0);
    beginShape();
    for (PVector point : c.get(index).getPolygonApproximation().getPoints()) {
      vertex(point.x+480, point.y);
    }
    endShape();
      if (Math.abs(dxi)>threshold) {



        if (dxi>0) {
          if (lastDir==-1) {
            if(keyPressesDirection){
              r.keyPress(KeyEvent.VK_DOWN);
              thread("releasedown");
            }
            
            text("LEFT", 240, 150);
            
          }
        } else {
          if (lastDir==1) {
            if(keyPressesDirection){
              r.keyPress(KeyEvent.VK_UP);
              thread("releaseup");
            }
            text("RIGHT", 240, 150);
          }
        }
      } else {
        text("GERADEAUS", 240, 150);
        lastDir=0;
      }

      
    }
    
  /**if(lefteye!=null){
   if(lefteye.length!=0){
   println("direction");
   text("dir",240,100);
   }
   }**/
  //PImage eye2=videoimg.get(eyes[1].x*2,eyes[1].y*2,eyes[1].width*2,eyes[1].height*2);
  //eye2.save("/home/johan/eye/2/"+num+".png");

  //println("home/johan/eye/2/"+num+".png");
  num++;
}
}
/**
* Prints an rectangle around the eyes
* @param drawColor Color of the Rectangles
* @param eyes rectangles around the eyes
**/
void printEyes(color drawColor, Rectangle[] eyes) {
  if (eyes!=null) {

    noFill();
    stroke(drawColor);
    strokeWeight(3);
    for (int i = 0; i<eyes.length; i++) if (eyes[i]!=null) rect(eyes[i].x, eyes[i].y, eyes[i].width, eyes[i].height);
  }
}
/**
* Key Inputs for controlling the program
* c Calibrates middle Position of the eye to the current
* e Enables key presses due to direction
* d disables them
* f fixes the eye rectangle, this doesn't work well(don't use it)
**/
void keyPressed() {
  if (key=='c'||key=='C') {
    calib=lastdx;
  }
  if (key=='e'||key=='E') {
    keyPressesDirection=true;
  }
  if (key=='d'||key=='D') {
    keyPressesDirection=false;
  }
  if (key=='f'||key=='F') {
    fix=lastEye;
  }
}

// Functions for releasing keys again
void releaseup() {
  try {  
    Thread.sleep(1);
    r.keyRelease(KeyEvent.VK_UP);
  }
  catch(Exception e) {
  }
}
void releasedown() {
  try {  
    Thread.sleep(1);
    r.keyRelease(KeyEvent.VK_DOWN);
  }
  catch(Exception e) {
  }
}
