package Eyetracking3;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.Robot;
import java.awt.event.KeyEvent;
import java.awt.image.BufferedImage;
import java.awt.image.DataBufferByte;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

import javax.imageio.ImageIO;

import org.opencv.core.Core;
import org.opencv.core.CvType;
import org.opencv.core.Mat;
import org.opencv.core.MatOfDMatch;
import org.opencv.core.MatOfKeyPoint;
import org.opencv.core.Point;
import org.opencv.core.Scalar;
import org.opencv.features2d.Features2d;
import org.opencv.features2d.ORB;
import org.opencv.highgui.HighGui;
import org.opencv.imgproc.Imgproc;
import com.github.sarxos.webcam.Webcam;
import processing.core.PApplet;
import processing.core.PImage;
import processing.core.PVector;

public class Eyetracking extends PApplet {

	public final int threshold = 250;// Grenze, wie viele Pixel(*50) die Pupille weiter rechts/links von der Mitte
										// sein muss, damit die Richtung erkannt wird.
	public static final int pupilSize = 50;// Größe der Pupille in Pixeln
	public boolean keyPressesDirection = false;
	public final boolean keyPressesBlink = false;
	public static final int minPupilRadius = 4;
	public static final int maxPupilRadius = 15;
	public static final double followFactor = 0.2;
	ResultPrinter print;
	Rectangle fix = null;
	Rectangle lastEye = null;
	KeyPointsTrain train = null;
	OpenCV opencv;
	Robot r;
	ORBDetector detector;
	Rectangle[] eyes;
	Rectangle lastfacecrop;
	Rectangle lastface;
	OpenCV cv2;
	double lastdx = 0.0;
	double calib = 0.0;
	int num = 0;
	Rectangle face = new Rectangle(0, 0, 1, 1);
	PImage img2;
	help_Functions h;
	Webcam webcam;

	public void settings() {
		detector=new ORBDetector(this);
		print = new ResultPrinter(this);
		h = new help_Functions();
		try {
			r = new Robot();
		} catch (Exception e) {
		}
		size(700, 360);

		opencv = new OpenCV((PApplet) this, 480, height);
		println(OpenCV.CASCADE_FRONTALFACE);
		opencv.loadCascade(OpenCV.CASCADE_FRONTALFACE);
		cv2 = new OpenCV(this, 480, height);
		cv2.loadCascade(OpenCV.CASCADE_EYE);

		// frameRate(3);
		webcam = Webcam.getDefault();
		webcam.open();
		// only needed for Webcam testing purposes.
		/**
		 * File outputfile = new File("image.jpg"); try {
		 * ImageIO.write(webcam.getImage(), "jpg", outputfile); } catch (IOException e)
		 * { e.printStackTrace(); }
		 **/
	}

	public void draw() {
		long start = millis();
		if (webcam.isImageNew()) {
			PImage img = new PImage((Image) webcam.getImage());
			img = img.get(160, 0, 960, 720);
			PImage img3 = new PImage((Image) img.getNative());
			img.resize(480, height);
			img.filter(GRAY);

			if (lastfacecrop != null) {
				// img=img.get(lastfacecrop.x,lastfacecrop.y,lastfacecrop.width,lastfacecrop.height);
				opencv.setROI(lastfacecrop.x, lastfacecrop.y, lastfacecrop.width, lastfacecrop.height);
			} else {
				opencv.setROI(0, 0, 480, height);
			}
			opencv.loadImage(img);
			image(img, 0, 0);
			Rectangle[] faces = getFaces();

			if (faces.length != 0) {
				if (lastfacecrop != null) {
					for (int i = 0; i < faces.length; i++) {
						faces[i].x += lastfacecrop.x;
						faces[i].y += lastfacecrop.y;
					}
				}
				lastface=faces[0];
				lastfacecrop = new Rectangle(faces[0].x - 20, faces[0].y - 20, faces[0].width + 40, faces[0].height + 40);
				lastfacecrop = lastfacecrop.intersection(new Rectangle(0, 0, 480, height));
				print.printFaces(color(0, 0, 255), faces);
				// img2=img.get(faces[0].x, faces[0].y, faces[0].width,
				// (int)(faces[0].height/1.5));
				img2 = img;
				Rectangle[] eyes = getEyes(faces[0]);
				

				if (train != null) {
					KeyPointsReference reference=detector.query(eyes, webcam.getImage(), face, false, train);
					MatOfDMatch match=detector.match(eyes, webcam.getImage(), face, train, reference, false);
					Point refPoint=reference.refPoint(match, train);
					fill(color(255,255,255));
					rect((float)refPoint.x,(float)refPoint.y,(float)5,(float)5);
					if (eyes != null) {
						if (eyes.length < 2 && keyPressesBlink) {
							r.keyPress(KeyEvent.VK_UP);
							thread("releaseup");
						}
						saveEyes(eyes, img3, faces[0],refPoint.x);
					}
				}
				
				print.printEyes(color(0, 255, 0), faces[0], eyes);
				print.printFaces(color(0, 0, 255), faces);
			} else {
				lastfacecrop = null;
			}
		}
		// println(millis()-start);
	}

	Rectangle[] getFaces() {
		Rectangle[] faces = opencv.detect();
		return faces;
	}

	Rectangle[] getEyes(Rectangle face) {
		this.face = face;
		thread("cvthreadeyes");
		// cvthreadeyes();
		// opencv.loadCascade(OpenCV.CASCADE_NOSE);
		// Rectangle[] noses = opencv.detect();
		if (eyes != null) {

			return eyes;
		} else
			return null;
	}

	public void cvthreadeyes() {

		cv2.loadImage(img2);
		cv2.setROI(face.x, face.y, face.width, (int) (face.height / 1.5));

		// OpenCV cv2=new OpenCV(this, img2);
		// cv2.loadCascade(OpenCV.CASCADE_EYE);
		eyes = cv2.detect();
		if (eyes != null) {
			for (int i = 0; i < eyes.length; i++) {

				// for (int k = 0; k<noses.length; k++) if (eyes[i]!=null &&
				// noses[k].contains(eyes[i])) eyes[i] = null;
				if (eyes[i] != null) {
					eyes[i].x += (face.x);
					eyes[i].y += (face.y);
				}
			}
		}
	}

	void saveEyes(Rectangle[] eyes, PImage videoimg, Rectangle face,double refx) {
		if (eyes.length > 1) {
			if (eyes[0].x > eyes[1].x) {
				Rectangle zwischen = eyes[0];
				eyes[0] = eyes[1];
				eyes[1] = zwischen;
			}
			lastEye = eyes[0];

			/**if (fix != null) {
				fix.x -= (fix.x - eyes[0].x) * followFactor;
				fix.y -= (fix.y - eyes[0].y) * followFactor;
				eyes[0] = fix;
			}**/
			PImage eye1 = videoimg.get(eyes[0].x * 2, eyes[0].y * 2, eyes[0].width * 2, eyes[0].height * 2);
			// eye1.save("/home/johan/eye/1/"+num+".png");

			image(eye1, 480, 0);
			OpenCV eyecv = new OpenCV(this, eye1.width, eye1.height);
			eyecv.loadImage(h.setThreshold(eye1, this));
			// eyecv.gray();
			// eyecv.blur(4);

			// eyecv.threshold(63);
			// eyecv.erode();
			image(eyecv.getOutput(), 480, 200);
			// eyecv.threshold(70);
			// eyecv.loadCascade("eye.xml");
			// Rectangle[] lefteye=eyecv.detect();
			ArrayList<Contour> c = eyecv.findContours();
			int index = h.leastCircularity(c);
			byte lastDir = 0;
			if (index != -1) {
				rect((float) (h.midx(c.get(index)) / 2.0 + eyes[0].x), (float) (h.midy(c.get(index)) / 2.0 + eyes[0].y),
						(float) 2, (float) 2);

				// double dx=midx(c.get(index))/2.0-eyes[0].width/2.0;
				double dx = h.midx(c.get(index)) / 2.0 - refx;
				lastdx = dx;
				dx -= calib;

				int dxi = (int) (dx * 100.0);
				if (Math.abs(dxi) > threshold) {
					if (dxi > 0) {
						lastDir = -1;
					} else {
						lastDir = 1;
					}
				} else {
					lastDir = 0;
				}

				text(dxi, 240, 100);
				h.drawContours(c, this);
			}
			while (!webcam.isImageNew()) {// Sadly needed to prevent freeze
			}
			PImage newEye = new PImage(webcam.getImage());
			eye1 = newEye.get(eyes[0].x * 2, eyes[0].y * 2, eyes[0].width * 2, eyes[0].height * 2);
			eyecv = new OpenCV(this, eye1.width, eye1.height);
			eyecv.loadImage(h.setThreshold(eye1, this));
			c = eyecv.findContours();
			index = h.leastCircularity(c);
			if (index != -1) {
				rect((float) (h.midx(c.get(index)) / 2.0 + eyes[0].x), (float) (h.midy(c.get(index)) / 2.0 + eyes[0].y),
						(float) 2, (float) 2);
				// double dx=midx(c.get(index))/2.0-eyes[0].width/2.0;
				double dx = h.midx(c.get(index)) / 2.0 - refx;
				lastdx = dx;
				dx -= calib;
				int dxi = (int) (dx * 100.0);
				stroke(0, 255, 0);
				beginShape();
				for (PVector point : c.get(index).getPolygonApproximation().getPoints()) {
					vertex(point.x + 480, point.y);
				}
				endShape();
				if (Math.abs(dxi) > threshold) {

					if (dxi > 0) {
						if (lastDir == -1) {
							if (keyPressesDirection) {
								r.keyPress(KeyEvent.VK_DOWN);
								thread("releasedown");
							}

							text("LEFT", 240, 150);

						}
					} else {
						if (lastDir == 1) {
							if (keyPressesDirection) {
								r.keyPress(KeyEvent.VK_UP);
								thread("releaseup");
							}
							text("RIGHT", 240, 150);
						}
					}
				} else {
					text("GERADEAUS", 240, 150);
					lastDir = 0;
				}

			}

			/**
			 * if(lefteye!=null){ if(lefteye.length!=0){ println("direction");
			 * text("dir",240,100); } }
			 **/
			// PImage
			// eye2=videoimg.get(eyes[1].x*2,eyes[1].y*2,eyes[1].width*2,eyes[1].height*2);
			// eye2.save("/home/johan/eye/2/"+num+".png");

			// println("home/johan/eye/2/"+num+".png");
			num++;
		}
	}

	public void keyPressed() {
		if (key == 'c' || key == 'C') {
			calib = lastdx;
		}
		if (key == 't' || key == 'T') {
			if(lastface!=null&&eyes!=null&&webcam.getImage()!=null) {
				train=detector.trainDescriptor(eyes, webcam.getImage(), lastface, true);
			}
		}
		if (key == 'e' || key == 'E') {
			keyPressesDirection = true;
		}
		if (key == 'd' || key == 'D') {
			keyPressesDirection = false;
		}
		if (key == 'f' || key == 'F') {
			fix = lastEye;
		}
	}

	public void releaseup() {
		try {
			Thread.sleep(1);
			r.keyRelease(KeyEvent.VK_UP);
		} catch (Exception e) {
		}
	}

	public void releasedown() {
		try {
			Thread.sleep(1);
			r.keyRelease(KeyEvent.VK_DOWN);
		} catch (Exception e) {
		}
	}
}