package Eyetracking3;

import java.util.ArrayList;
import java.util.Vector;

import org.opencv.core.DMatch;
import org.opencv.core.KeyPoint;
import org.opencv.core.Mat;
import org.opencv.core.MatOfDMatch;
import org.opencv.core.MatOfKeyPoint;
import org.opencv.core.Point;

public abstract class KeyPointDescriptor {
	MatOfKeyPoint pt;
	Mat desc;
	ArrayList<int[]> vectors = new ArrayList<int[]>();
	Point refPoint = new Point(300, 300);
	Mat image;
	boolean train;

	public Mat getImage() {
		return image;
	}

	public KeyPointDescriptor(MatOfKeyPoint point, Mat descriptor, Mat image) {
		desc = descriptor;
		train=true;
		pt = point;
		this.image=image;
		KeyPoint[] points = pt.toArray();
		for (int i = 0; i < points.length; i++) {
			int[] vector = new int[2];
			vector[0] = (int) (refPoint.x - points[i].pt.x);
			vector[1] = (int) (refPoint.y - points[i].pt.y);
			vectors.add(vector);

		}
	}

	public KeyPointDescriptor(MatOfKeyPoint point, Mat descriptor, Mat image, ArrayList<int[]> vectors) {
		desc = descriptor;
		this.image=image;
		train=false;
		pt = point;
		KeyPoint[] points = pt.toArray();
		this.vectors = vectors;

	}

	public MatOfKeyPoint getKeyPoint() {
		return pt;
	}

	public Mat getDescriptors() {
		return desc;
	}

	public Point getPointAt(int index) {
		KeyPoint[] points = pt.toArray();
		return points[index].pt;
	}
}
