package Eyetracking3;

import java.awt.Rectangle;
import java.awt.image.BufferedImage;

import com.github.sarxos.webcam.WebcamEvent;
import com.github.sarxos.webcam.WebcamListener;
import com.github.sarxos.webcam.WebcamMotionEvent;

public class CamListener implements WebcamListener {
	boolean newThreadImage = false;
	boolean newCascadeImage = false;
	boolean ThreadsAllowed = false;
	TrainImageThread imgThread;
	Thread obtain;
	Rectangle[] eyes;
	Rectangle face;
	KeyPointsTrain train;
	ORBDetector detector;

	ORBThread[] t = new ORBThread[3];
	BufferedImage img;

	public CamListener() {
		for (int i = 0; i < t.length; i++) {
			t[i] = new ORBThread();
		}

	}

	@Override
	public void webcamClosed(WebcamEvent arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void webcamDisposed(WebcamEvent arg0) {
		// TODO Auto-generated method stub

	}

	@Override
	public void webcamImageObtained(WebcamEvent arg0) {
		newThreadImage = true;
		newCascadeImage = true;
		img = arg0.getImage();
		if (ThreadsAllowed) {
			boolean started = false;
			for (int i = 0; i < t.length && !started; i++) {

				started = t[i].start(eyes, img, face, train, detector, i);

			}
			if (obtain != null) {
				if (obtain.isAlive()&&imgThread.isCollecting()) {
					
					
					obtain.interrupt();//Very Very Very ugly workaround(I dont know anything about Multithreading)
				} else if(!obtain.isAlive()){
					obtain = null;
				}
			}

		}
	}

	public void allowThreads(Rectangle[] eyes, Rectangle face, KeyPointsTrain train, ORBDetector detector) {
		this.eyes = eyes;
		this.face = face;
		this.train = train;
		this.detector = detector;
		ThreadsAllowed = true;
	}

	@Override
	public void webcamOpen(WebcamEvent arg0) {
		// TODO Auto-generated method stub

	}

	public boolean isNewThreadImage() {
		return newThreadImage;
	}

	public boolean isNewCascadeImage() {
		return newCascadeImage;
	}

	public BufferedImage cascadeImage() {
		newCascadeImage = false;
		return img;
	}

	public synchronized BufferedImage threadImage() {
		newThreadImage = false;
		return img;
	}

	public void obtaintrainImages(int num) {
		imgThread=new TrainImageThread(num, this);
		obtain = new Thread(imgThread,"Train_OpenCV");
		obtain.start();

	}
	public KeyPointsTrain trainSet() {
		if(imgThread==null)
			return null;
		else
			return imgThread.trainSet();	
	}
	public Thread trainImageThread() {
		return obtain;
	}

}
