import java.awt.Point;
import java.awt.Color;

public class Button extends GameObject{
  boolean enabled;
  Color c=Color.BLACK;
  String label="";
  int fontSize=10;
  /**
  * Constructor for enabled button.
  * @param button Rectangle, where the button will be drawed
  * 
  **/
  public Button(Rectangle button){
    super(button);
    enabled=true;
  }
  /**
  * Constructor
  * @param button Rectangle, where the button will be drawed
  * @param enableda sets the button to enabled if true or disabled. A disabled button isn't visible
  **/
  public Button(Rectangle button,boolean enableda){
    super(button);
    enabled=enableda;
  }
  public void update(){
    // Do nothing
  }
  // Returns true if x,y coordinates are inside the button area and the button is enabled
  public boolean clicked(int x,int y){
    Point p=new Point(x,y);
    if(getHitbox().contains(p)&&enabled) 
      return true;
    else 
      return false;
  }
  // Sets the text of the button
  public void setText(String text){
    label=text;
    double x=getHitbox().getCenterX();
    double y=getHitbox().getCenterY();
    fontSize=300;
    Rectangle r=new Rectangle(-2,-2,1,1);
    while(!getHitbox().contains(r)){
      textSize(fontSize);
      r=middleRectangle((int)x,(int)y,(int)(textWidth(label)*1.1),(int)(fontSize*1.1));
      fontSize--;
    }
  }
  // Draws the button, this Function should be executed every Frame(the button is only drawed ehen it's enabled)
  public void print(){
    color zwischen=color(c.getRed(),c.getGreen(),c.getBlue());
    if(enabled) {
      super.printHitbox(zwischen);
      fill(color(255-red(zwischen),255-green(zwischen),255-blue(zwischen)));
      //rectMode(RADIUS);
      textSize(fontSize);
      text(label,(float)getHitbox().getCenterX()-textWidth(label)/2,(float)getHitbox().getCenterY()+fontSize/2-5);
      rectMode(CORNER);
    }
  }
  // Enabes the button
  public void enable(){
    enabled=true;
  }
  // Disables the Button
  public void disable(){
    enabled=false;
  }
}
