public class Player extends GameObject {
  private float jumpspeed; //speed the player initially has when jumping.
  private float ySpeed; //current speed the player has in the y-direction.
  private int duck; //determines weather the player is ducked or not.
  private Health health; //current health of the player.
  private final int maxHealth = 300; //maximal health the player can have.
  private final int regeneration = 1; //health the player regenerates per update.
  
  public Player(Rectangle hitbox, float jumpspeed) {
    super(hitbox);
    this.jumpspeed=jumpspeed;
    ySpeed = 0;
    duck=0;
    health = new Health(maxHealth);
  }
  
  //initiates a jump
  public void jump() {  
    if (ySpeed == 0&&duck<-15) ySpeed = jumpspeed;
  }
  
  //initiates a slide
  public void duck(float groundY,boolean gravitation){
    duck=100;
    Rectangle r=(Rectangle)(getHitbox());
    r.height=40;
    if(!gravitation) 
      r.y=0;
    else
      r.y=(int)(groundY-40);
  }
  
  //updates the players position according to the speed of the level he is part of and his current speed in the y-direction.
  //regenerates the players health.
  public void update(float gravitation, float groundY,float speed) {
    health.changeHealth(regeneration);
    Rectangle hitbox = (Rectangle)getHitbox();
    if (ySpeed !=0 || hitbox.y+hitbox.height !=groundY) {
      hitbox.setLocation(hitbox.x, (int)(hitbox.y-ySpeed));
      ySpeed-=gravitation;
    }
    if (hitbox.y+hitbox.height>=groundY) {
      hitbox.setLocation(hitbox.x, (int)groundY-hitbox.height);
      ySpeed = 0;
      if (gravitation<0) {
        ySpeed=-jumpspeed;
      }
    }
    if(duck<0){
      hitbox.height=70;
      if(duck>=-20)duck-=speed;
    }else{
      duck-=speed;
    }  
    
    if (hitbox.y<=0) {
      hitbox.setLocation(hitbox.x, 0);
      ySpeed = 0;
      if (gravitation>0) {
        ySpeed=-jumpspeed;
      }
    }
  }
  
  //returns the players maximum jumpheight in a given gravitation.
  public int getJumpheight(float gravitation){
    float speed = Math.abs(jumpspeed);
    int x = 1000;
    int minX = 1000;
    while(x<=1000){
      x-=speed;
      speed-=Math.abs(gravitation);
      if(x<minX) minX = x;
    }
    return 1000-minX;
  }
  
  //negates the initall direction of the jump.
  public void negateJumpspeed(){
    jumpspeed = -jumpspeed;
  }
  
  //sets the players jumpspeed to a passed value.
  public void setJumpspeed(float jumpspeed){
    this.jumpspeed = jumpspeed;
  }
  
  //returns the players jumpspeed.
  public float getJumpspeed(){
    return jumpspeed;
  }
  
  //returns the players current health.
  public Health getHealth(){
    return health;
  }
  
}
