public abstract class Segment{
  private boolean invGrav; //true if the gravitation is inverted, otherwise false
  private ArrayList<GameObject> objects; //list of obstacles in the segment
  private int lastX; //x-coordinate of the last obstacle in the segment
  private int startX; //x-coordinate of the first obstacle in the segment
  private int abstand; //average distance between the obstacles
   
  public Segment(int startX, boolean invGrav){
    this.startX = startX;
    this.invGrav = invGrav;
    objects = new ArrayList<GameObject>();
    abstand = 170;
    lastX=0;
  }
  
  //adds obstacle with the passed attributes to the segment
  public void addObstacle(int x, int hoehe, int breite, boolean slide){
    if(!slide){
      if(!invGrav) objects.add(new Obstacle(new Rectangle(x,height-hoehe,breite,hoehe)));
      else objects.add(new Obstacle(new Rectangle(x,0,breite,hoehe-10)));
    }else{
      if(!invGrav) objects.add(new Obstacle(new Rectangle(x,height-hoehe-50,breite,hoehe)));
      else objects.add(new Obstacle(new Rectangle(x,40,breite,hoehe-10)));
    }   
  }
  
  //adds gravity object with passed attributes to the segment
  public void addGravity(int x, int breite){
    objects.add(new Gravity(new Rectangle(x,0,breite,height)));
    invGrav = !invGrav;
  }
  
  //not used in the final version of the game 
  /*
  public void addFinish(int x, int breite){
    objects.add(new Finish(new Rectangle(x,0,breite,height)));
  }*/
  
  //returns alls Objects of the segment
  public ArrayList<GameObject> getObjects(){
    return objects;
  }
  
  //sets the state gravity of the segement to the passed value
  public void setGrav(boolean invGrav){
    this.invGrav=invGrav;
  }
  
  //returns the state of the gravity in the segment
  public boolean getGrav(){
    return invGrav;
  }
  
  //sets the x-coordinate of the last object in the segment to a passed value 
  public void setLastX(int lastX){
    this.lastX = lastX;
  }
  
  //returns the x-coordinate of the last obstacle 
  public int getLastX(){
    return lastX;
  }
  
  //returns the average distance between the objects in the segment
  public int getAbstand(){
    return abstand;
  }
}
