# Eyetracking Spiel
Dieses Projekt ist im Rahmen des Robotik-Labors des Orientierungsstudiums MINTgruen entstanden.
## Installationsanleitung

Zuerst muss Processing installiert werden: [Download](https://processing.org/download/)

In Processing müssen dann die Libraries OpenCV und Video installiert werden. Dies wird hier exemplarisch an der Library Video gezeigt. Das Vorgehen für die Library OpenCV ist identisch.
![Bild1](img/01.png)

![Bild2](img/02.png)

![Bild2](img/03.png)

Wenn die Libraries erfolgreich installiert worden sind, kann man die Datei Game.pde im Ordner Game in Processing öffnen um das Spiel zu starten.
Das Eyetracking befindet sich im Ordner Eyetracking/Eyetracking.pde.
Um das Programm auszuführen muss der Startknopf oben links in Processing gedrückt werden.
## Anleitung zum Eyetracking
Das Eyetracking erkennt nur die Bewegungsrichtung rechts/links.
Mit der Taste c kann die Blickrichtung kalibriert werden.
Die Blickrichtung ergibt folgende Tasteneingaben: 
Links=Pfeiltaste unten
Rechts=Pfeiltaste oben
Die Tasteneingaben können mit e aktiviert und mit d deaktiviert werden.
Das Eyetracking funktioniert noch nicht zuverlässig. Es ist so gut wie unmöglich das Spiel damit zu steuern. Eine gute Beleuchtung kann dabei helfen die Ergebnisse zu verbessern.

## Erklärung zu den Ordnern
Wie schon oben erwähnt befinden sich die für die Benutzung wichtigen Dateien in den Ordnern Game und Eyetracking.
Im Ordner Eyetracking_Java befindet sich die derzeit noch nicht fertige Version des Eyetrackings die einen besseren Fixpunkt nutzen soll, um das Eyetracking zu verbessern. Diese nutzt im Gegensatz zu der anderen Version nicht Processing direkt, sondern nutzt die Processing Library unter Java.
Der Ordner img umfasst die Dateien, die im Readme angeziegt werden
Der Ordner Wiki umfasst die Projektplanung die als gerenderte Seite unter [Robotik Wiki](https://www.mintgruen.tu-berlin.de/robotikWiki/doku.php?id=projektesose20:eyetrackingspiel:start)

## Ordnerstruktur
**.git**                                Ignore this, only needed for GIT repository

**Eyetracking**                         Eyetracking Processing Version

**Eyetracking_Java**                    Same as Eyetracking_Java_Multithreading, but with limited multithreading, but more failsafe

**Eyetracking_Java_Multithreading**     Eyetracking using ORB algorithm, only for advanced users, copied from Eclipse Workspace

 * **src**                              Java Files

 * **cascade Files**                    All Cascades from OpenCV, used for eye and face detection, not all cascades are needed.

**Game**                                Programmed Game

**img**                                 Images for Readme file

**release**                             Runnable Jars of Game

**eyetracking.gan**                     GanTT Diagramm

